'
'----------------------------------------------------------------------------------------'
'	Edit in Notepad. Disable Word Wrap, Use font Courier New, Regular, Size 10.	 '
'----------------------------------------------------------------------------------------'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
'			VBScript Install Application for Titan64e.exe			 '
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
'											 '
'	Purpose		:	Install & Setup Titan64e.exe				 '
'	------------------------------------------------------------------------   	 '
'	Creation Date	: 	10/06/2021 [dd/mm/yyyy]				   	 '
'	Version		:	1.2							 '
'	Designer	:	Matt Byrne (Horizon Software Engineering)		 '
'											 '
'########################################################################################'
'			MODIFICATION HISTORY						 '
'----------------------------------------------------------------------------------------'
'	Version		:	1:0	10/06/2021	Create the Application		 '
'			:	1:1	13/06/2021 	Add StartMenu Shortcut		 '
'			:	1:2	20/06/2021	Add RUNASADMIN Reg Entries  	 '
'											 '
'----------------------------------------------------------------------------------------' 
'
'
		
Dim FSO													'As Object
Dim WshShell												'As Object
Dim objReg												'As Object
Dim objWMIService											'As Object
Dim RunAsAdminDictionary										'As Object

Dim SystemAddressWidth			

Dim StrThisScriptPath
Dim StrInstallationDirCheck   
Dim StrDriveUserName
Dim StrFullContainerPath

Dim CheckForFFmpegPath
Dim CheckForFFprobePath
Dim CheckForFFplayPath
Dim CheckForTitanPath

Dim RegisterFFmpeg
Dim RegisterFFprobe
Dim RegisterFFplay
Dim RegisterTitan64

Dim RegFilePath

Dim IntCounter 

Dim qRetVal												'As VbMsgBoxResult												

Dim strValueName

Set FSO = CreateObject("Scripting.FileSystemObject")							'FSO File System Object
Set WshShell = Wscript.CreateObject("Wscript.Shell")							'WshShell Windows Scripting Host
Set objReg = Getobject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:stdregprov")		'Standard Registry Provider (my understanding)
Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2") 						'Windows Management Instrumentation
Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Processor",,48) 				'Windows Management Instrumentation
Set RunAsAdminDictionary = CreateObject("Scripting.Dictionary")						'Dictionary

Const StrUserName = "Desktop"

Const IntPause = 100

Const ObjFFmpeg = "ffmpeg.exe"
Const ObjFFprobe = "ffprobe.exe"
Const ObjFFplay = "ffplay.exe"
Const ObjTitan = "Titan64e.exe"

Const LicenceAgreeL1 = "If you have agreed to the Freeware Licence Terms of use."
Const LicenceAgreeL2 = "This VBScript Application will install Titan64e on your Device."
Const LicenceAgreeL3 = "Select Yes to Install or No to Exit."
Const LicenceAgreeL4 = "Confirm Install"

Const ErrMSG = "Error: The process took too long to complete."
Const ErrTOP = "Failed."

Const InstallMSG = "Install of Titan64e Completed."
Const InstallTOP = "Titan64e Installation"

Const UACpermissionL1 = "Titan64e requires Run As Administrator, Privileges."
Const UACpermissionL2 = "Your Systems UAC, will now prompt you for permission."
Const UACpermissionL3 = "Register Application"

Const RegFailedL1 = "Error: The Registry of Titan64e failed."
Const RegFailedL2 = "Run As Admin Failed."

Const RegCompletedL1 = "Success: The Registry of Titan64e Succeeded"
Const RegCompletedL2 = "Run As Admin"

Const AppInstallPath = "<%DriveUser%>\AppData\Local\" 

Const AppContainingDir = "HorizonSoftwareEngineering"

Const AppNameDir = "Titan64e"
Const AppShortcut = "\Titan64e.lnk"
Const HKEY_CURRENT_USER = &H80000001
Const strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers\"
Const KeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers\"
Const strValue = "RUNASADMIN"
Const AppAdminReg = "[HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers]"
Const CheckRegInstall = "[HKEY_CURRENT_USER\"

For Each objItem in colItems 

'----------------------------------------------------------------------------------------
'	Determine if the system is a 64bit or 32bit platform
'----------------------------------------------------------------------------------------
   
   SystemAddressWidth = objItem.AddressWidth

Next

'----------------------------------------------------------------------------------------
'	request confirmation of Installation of the Freeware from user
'----------------------------------------------------------------------------------------

	qRetVal = MsgBox(LicenceAgreeL1 & VbCrLf & LicenceAgreeL2 & VbCrLf & VbCrLf & _
		LicenceAgreeL3, VbSystemModal+VbExclamation+VbYesNoCancel,LicenceAgreeL4)

Select Case qRetVal

Case VbYes

Call ScriptOrientation()

Case VbNo

	WScript.Quit

Case VbCancel

	WScript.Quit

Case Else: WScript.Quit

End Select

Public Sub ScriptOrientation()
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Get the current location of this Script & Set the Variables
'----------------------------------------------------------------------------------------

	StrDirtyPath01 = WScript.ScriptFullName 
	StrDirtyPath02 = Mid((StrDirtyPath01),1, Len(StrDirtyPath01)-Len(WScript.ScriptName)-1)
	StrThisScriptPath = Trim(StrDirtyPath02)

	RegFilePath = (StrThisScriptPath & RegFileName): RegFilePath = Trim(RegFilePath)
	
	StrDesktopPath = WshShell.SpecialFolders(StrUserName)

If InStrRev((StrDesktopPath),Chr(92),-1,1) Then
	
	IntCutPos = InStrRev((StrDesktopPath),Chr(92),-1,1)

	StrDriveUserName = Mid((StrDesktopPath),1,(IntCutPos)-1)
	StrPartialBuildPath = Replace(AppInstallPath,"<%DriveUser%>",StrDriveUserName)
	StrFullContainerPath = (Trim(StrPartialBuildPath) & AppContainingDir)

End If

Call CheckInstallLocation()

End Sub

Public Sub CheckInstallLocation()
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Check existance of <%DriveUser%>\AppData\Local\HorizonSoftwareEngineering\
'----------------------------------------------------------------------------------------

If FSO.FolderExists(StrFullContainerPath) Then

Call CheckAppDirExists()

Else

Set ApplicationDirectory = FSO.CreateFolder(StrFullContainerPath): CreateAppDirectory = ApplicationDirectory.Path

WScript.Sleep ((IntPause)*30)

Call CheckAppDirExists()

End If

End Sub

Public Sub CheckAppDirExists()
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Check existance of a previous installation: Create the directories if required
'----------------------------------------------------------------------------------------

	StrFullContainerPath = (StrFullContainerPath & Chr(92) & AppNameDir)

If FSO.FolderExists(StrFullContainerPath) Then

Call InstallProcess()

Else

Set ApplicationDirectory = FSO.CreateFolder(StrFullContainerPath): CreateAppDirectory = ApplicationDirectory.Path

WScript.Sleep ((IntPause)*30)

Call InstallProcess()

End If

End Sub

Public Sub InstallProcess()
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Copy the contents of the installation directory over to the install path
'----------------------------------------------------------------------------------------

	StrFullContainerPath = Trim(StrFullContainerPath)

'----------------------------------------------------------------------------------------
'	A Wild-Card File-Copy routine ""\*.*","
'----------------------------------------------------------------------------------------
	
FSO.CopyFile StrThisScriptPath & "\*.*", StrFullContainerPath

	IntCounter = 1

Call RegisterApps()

End Sub

Public Sub RegisterApps()
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Allow enough time for the copy process, then build the path to each EXE
'----------------------------------------------------------------------------------------

	IntCounter = IntCounter + 1

If IntCounter > 9 Then

	Msgbox ErrMSG,VbSystemModal+VbExclamation+VbOkCancel,ErrTOP

	WScript.Quit

End If

	CheckForFFmpegPath = (StrFullContainerPath & Chr(92) & ObjFFmpeg)
	CheckForFFprobePath = (StrFullContainerPath & Chr(92) & ObjFFprobe)
	CheckForFFplayPath = (StrFullContainerPath & Chr(92) & ObjFFplay)
	CheckForTitanPath = (StrFullContainerPath & Chr(92) & ObjTitan)

If FSO.FileExists(CheckForFFmpegPath) And _
	FSO.FileExists(CheckForFFprobePath) And _
	FSO.FileExists(CheckForFFplayPath) And _
	FSO.FileExists(CheckForTitanPath)  Then

Call RegisterRoutines()

Else

WScript.Sleep ((IntPause)*10): Call RegisterApps()

End If

End Sub

Public Sub RegisterRoutines()
On Error Resume Next

Dim i

'----------------------------------------------------------------------------------------
'	App.Compatibility flags set as "RUNASADMIN" in the system Registry
'----------------------------------------------------------------------------------------

	RegisterFFmpeg =  Chr(34) & CheckForFFmpegPath & Chr(34) & "=" & Chr(34) & RunAsAdminStr & Chr(34)
	RegisterFFmpeg = Replace((RegisterFFmpeg),Chr(92),Chr(92) & Chr(92))

	RegisterFFprobe = Chr(34) & CheckForFFprobePath & Chr(34) & "=" & Chr(34) & RunAsAdminStr & Chr(34)      
	RegisterFFprobe = Replace((RegisterFFprobe),Chr(92),Chr(92) & Chr(92))

	RegisterFFplay = Chr(34) & CheckForFFplayPath & Chr(34) & "=" & Chr(34) & RunAsAdminStr & Chr(34)      
	RegisterFFplay = Replace((RegisterFFplay),Chr(92),Chr(92) & Chr(92))

	RegisterTitan64 = Chr(34) & CheckForTitanPath & Chr(34) & "=" & Chr(34) & RunAsAdminStr & Chr(34)      
	RegisterTitan64 = Replace((RegisterTitan64),Chr(92),Chr(92) & Chr(92))

With RunAsAdminDictionary

	.Add 0, CheckForFFmpegPath
	.Add 1, CheckForFFprobePath
	.Add 2, CheckForFFplayPath
	.Add 3, CheckForTitanPath 

End With

'----------------------------------------------------------------------------------------
'	WshShell fails in Windows 10 to write these values. 
'	Solution:	Use WMI stdregprov Routines to Read & Write Registry Data
'----------------------------------------------------------------------------------------

For i = 0 To RunAsAdminDictionary.Count -1

	objReg.SetStringValue HKEY_CURRENT_USER,strKeyPath,RunAsAdminDictionary(i),strValue

Next

WScript.Sleep ((IntPause)*50)

Call CreateDesktopShortcut()

End Sub

Public Sub CreateDesktopShortcut()
On Error Resume Next

Dim TitanShortcut
Dim strDesktop
Dim REGHKEY
Dim InstalledDriveLabel 
Dim ConfigureStartMenu

'----------------------------------------------------------------------------------------
'	Place a Shortcut on the users desktop to complete the installation
'----------------------------------------------------------------------------------------

	strDesktop = WshShell.SpecialFolders(StrUserName)

Set TitanShortcut = WshShell.CreateShortcut(strDesktop + AppShortcut)

	TitanShortcut.TargetPath = CheckForTitanPath

	TitanShortCut.Save

'----------------------------------------------------------------------------------------
'	Create a Start Menu Shortcut: Not used here.
'----------------------------------------------------------------------------------------
'
'WScript.Sleep ((IntPause)*40)
'
'	InstalledDriveLabel = Left((TitanShortCut),2)
'
'	ConfigureStartMenu = InstalledDriveLabel & AppMenuLink & AppShortcut
'
'FSO.CopyFile TitanShortcut, ConfigureStartMenu 
'
'----------------------------------------------------------------------------------------

WScript.Sleep ((IntPause)*30)

If SystemAddressWidth <> 64 Then: Exit Sub

'----------------------------------------------------------------------------------------
'	Check to see that, the Registry accepted the Run As Administrator flags.
'	64-bit Systems
'----------------------------------------------------------------------------------------

Set Inparams = objReg.Methods_("GetStringValue").Inparameters

	REGHKEY = Mid((AppAdminReg),20,Len(AppAdminReg) -Len((CheckRegInstall)) -1)

With Inparams

	.Hdefkey = HKEY_CURRENT_USER
	.Ssubkeyname = Trim(strKeyPath)
	.Svaluename = CheckForTitanPath

End With

Set Outparams = objReg.ExecMethod_("GetStringValue", Inparams)

If InStr(1,(Outparams.SValue),RunAsAdminStr) Then

'----------------------------------------------------------------------------------------
'	un/comment to show/hide notifications
'----------------------------------------------------------------------------------------
'	
'	Reg Succeeded
	Msgbox RegCompletedL1, VbSystemModal+VbExclamation+VbOkOnly, RegCompletedL2

Else

'	Reg Failed
	Msgbox RegFailedL1, VbSystemModal+VbExclamation+VbOkOnly, RegFailedL2

End If

'----------------------------------------------------------------------------------------
'	release the objects: cleanup
'----------------------------------------------------------------------------------------

Set FSO = Nothing
Set WshShell = Nothing
Set Outparams = Nothing
Set objReg = Nothing
Set objWMIService = Nothing
Set colItems = Nothing

End Sub


