'
'----------------------------------------------------------------------------------------'
'	Edit in Notepad. Disable Word Wrap, Use font Courier New, Regular, Size 10.	 '
'----------------------------------------------------------------------------------------'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
'			VBScript: Un-Install Titan64e.exe			 	 '
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
'											 '
'	Purpose		:	Un-Install Titan64e.exe				 	 '
'	------------------------------------------------------------------------   	 '
'	Creation Date	: 	21/06/2021 [dd/mm/yyyy]				   	 '
'	Version		:	1.1							 '
'	Designer	:	Matt Byrne (Horizon Software Engineering)		 '
'											 '
'########################################################################################'
'			MODIFICATION HISTORY						 '
'----------------------------------------------------------------------------------------'
'	Version		:	1:0	21/06/2021	Create the Application		 '
'											 '
'----------------------------------------------------------------------------------------' 
'
'
	
Dim FSO					'As Object
Dim WshShell				'As Object
Dim DeleteDictionary			'As Object
Dim objReg				'As Object
Dim objWMIService			'As Object

Dim RetVal				'As VbMsgBoxResult
	
Dim Return				'As Long

Dim SystemAddressWidth	
Dim UserDesktopPath	

Dim StrFullContainerPath									

Set FSO = CreateObject("Scripting.FileSystemObject")							
Set WshShell = WScript.CreateObject("WScript.Shell")	
Set DeleteDictionary = CreateObject("Scripting.Dictionary")
Set objReg = Getobject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:stdregprov")		
Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2") 						
Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Processor",,48) 

Const ObjFFmpeg = "\ffmpeg.exe"
Const ObjFFprobe = "\ffprobe.exe"
Const ObjFFplay = "\ffplay.exe"
Const ObjTitan = "\Titan64e.exe"

Const UNinstallMSG01 = "Titan64e has been located on this machine."
Const UNinstallMSG02 = "Are you sure you want to UN-Install it now ?"
Const UNinstallMSG03 = "Uninstall Titan64e"

Const NotFoundMSG01 = "Titan64e cannot been located on this machine."
Const NotFoundMSG02 = "Try removing Titan64e manually."
Const NotFoundMSG03 = "Titan64e Not Found"

Const UnInstL1 = "Titan64e Removal: Completed Successfuly"
Const UnInstL2 = "Titan64e Un-Install"

Const RegDeleteFailedL1 = "Delete Key Failed. Error = "
Const RegDeleteFailedL2 = "Uninstall Titan64e"

Const RegDeleteSucesL1 = "Delete Key Succeeded"
Const RegDeleteSucesL2 = "Uninstall Titan64e"

Const strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers"	
		
Const AppInstallPath = "<%DriveUser%>\AppData\Local\" 
Const AppContainingDir = "HorizonSoftwareEngineering"
Const AppNameDir = "\Titan64e"
Const AppShortCut = "\Titan64e.lnk"

Const HKEY_CURRENT_USER = &H80000001 

	UserDesktopPath = WshShell.SpecialFolders("Desktop")

For Each objItem in colItems 
   
   SystemAddressWidth = objItem.AddressWidth

Next

If InStrRev((UserDesktopPath),Chr(92),-1,1) Then

'----------------------------------------------------------------------------------------
'	Orientation of the Script. Where are we on the System
'----------------------------------------------------------------------------------------
	
	IntCutPos = InStrRev((UserDesktopPath),Chr(92),-1,1)

	StrDriveUserName = Mid((UserDesktopPath),1,(IntCutPos)-1)
	StrPartialBuildPath = Replace(AppInstallPath,"<%DriveUser%>",StrDriveUserName)
	StrFullContainerPath = (Trim(StrPartialBuildPath) & Trim(AppContainingDir) & Trim(AppNameDir))

End If

If FSO.FolderExists(StrFullContainerPath) Then

	RetVal = MsgBox(UNinstallMSG01 & VbCrLf & UNinstallMSG02,VbSystemModal+VbExclamation+VbYesNoCancel,UNinstallMSG03)

Select Case RetVal

Case VbYes

'----------------------------------------------------------------------------------------
'	Confirmation of Removal. Proceed and Remove the Titan64e App
'----------------------------------------------------------------------------------------

Call DeleteTitanDir()

Case VbNo

'----------------------------------------------------------------------------------------
'	No Confirmation of Removal. Do Not Proceed. Exit the Script.
'----------------------------------------------------------------------------------------

	 WScript.Quit

Case VbCancel

	 WScript.Quit

Case Else: WScript.Quit

End Select  

Else

   	MsgBox NotFoundMSG01 & VbCrLf & NotFoundMSG02,VbSystemModal+VbExclamation+VbOkOnly,NotFoundMSG03

End If

Public Sub DeleteTitanDir()
On Error Resume Next

Dim GetTitanShortCut

'----------------------------------------------------------------------------------------
'	Remove the Titan64e App Directory
'----------------------------------------------------------------------------------------

	FSO.DeleteFolder(StrFullContainerPath)

'----------------------------------------------------------------------------------------
'	Remove the Titan64e Desktop Shortcut
'----------------------------------------------------------------------------------------

	GetTitanShortCut = (UserDesktopPath & AppShortCut)

If (FSO.FileExists(GetTitanShortCut)) Then

	FSO.DeleteFile(GetTitanShortCut)

End If

Call BuildRegEntries()

End Sub

Public Sub BuildRegEntries()
On Error Resume Next

Dim i

'----------------------------------------------------------------------------------------
'	Load the Dictionary with the path's of Titan64e and the FFmpeg objects
'	The path's are the Registry Entries that need to be removed.
'----------------------------------------------------------------------------------------

With DeleteDictionary

	.Add 0, ObjFFmpeg
	.Add 1, ObjFFprobe
	.Add 2, ObjFFplay
	.Add 3, ObjTitan

End With

For i = 0 To DeleteDictionary.Count -1

Call DeleteTitanRegEntries(DeleteDictionary(i))

Next

	MsgBox UnInstL1,VbSystemModal+VbExclamation+VbOkOnly,UnInstL2

'----------------------------------------------------------------------------------------
'	Release the Objects / Cleanup and Exit.
'----------------------------------------------------------------------------------------

Set FSO = Nothing						
Set WshShell = Nothing
Set DeleteDictionary = Nothing
Set objReg = Nothing	
Set objWMIService = Nothing						
Set colItems = Nothing 

End Sub

Public Sub DeleteTitanRegEntries(ByRef RegDeleteKey)
On Error Resume Next

'----------------------------------------------------------------------------------------
'	Remove the Titan64e RUNASADMIN Registry Entries
'----------------------------------------------------------------------------------------

	strValueName = Trim(StrFullContainerPath & RegDeleteKey)

	Return = objReg.DeleteValue(HKEY_CURRENT_USER,strKeyPath,strValueName)

'----------------------------------------------------------------------------------------
'	un/comment to display/hide dialogs
'----------------------------------------------------------------------------------------

If (Return = 0) And (Err.Number = 0) Then    

'    MsgBox RegDeleteSucesL1 & _
'	VbCrLf & VbCrLf & "HKEY_CURRENT_USER\" & strKeyPath & strValueName, VbSystemModal+VbExclamation+VbOkOnly, RegDeleteSucesL2

Else

'    MsgBox RegDeleteFailedL1 & Err.Number & _
'	VbCrLf & VbCrLf & "HKEY_CURRENT_USER\" & strKeyPath & strValueName, VbSystemModal+VbExclamation+VbOkOnly, RegDeleteFailedL2

End If
	
End Sub

